# define driver name, version and release
%define		drvname	nvidia304
%define		drvver	304.119
%define		drvrel	1.mga4.nonfree

# define core kernel version we build against
%define 	kernver		3.12.13
%define		kernrel		2.mga4

# where to build
%define		topdir		${RPM_BUILD_DIR}/%{name}-%{_arch}

# source package
Name:		kmod-%{drvname}
Version:	%{drvver}
Release:	%mkrel 5
Summary:	Prebuilt %{drvname} modules for kernel-%{kernver}-%{kernrel}
License:	Freeware
URL:		http://www.nvidia.com/object/unix.html
Group:		System/Kernel and hardware
ExclusiveArch:	%{ix86} x86_64

BuildRequires:	dkms-%{drvname} = %{drvver}-%{drvrel}
%ifarch %{ix86}
BuildRequires:	kernel-desktop586-devel-%{kernver}-%{kernrel}
%endif
BuildRequires:	kernel-desktop-devel-%{kernver}-%{kernrel}
BuildRequires:	kernel-server-devel-%{kernver}-%{kernrel}

%description
This package creates prebuilt %{drvname} kernel modules for core kernel.


# obsoletes prebuilt -netbook-latest modules with matching -desktop-latest
%define latest_obsoletes_desktop %{drvname}-kernel-netbook-latest < 304.64-2
%define latest_provides_desktop  %{drvname}-kernel-netbook-latest = %{drvver}-%{release}

##### mkflavour() ala core kernel #####
%define mkflavour()								\
%package -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Summary:	%{drvname} driver for kernel-%{1}-%{kernver}-%{kernrel}		\
License:	Commercial							\
URL:		http://www.nvidia.com/object/unix.html				\
Group:		System/Kernel and hardware					\
Requires(post): dkms-minimal							\
Requires(preun): dkms-minimal							\
Requires:	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(post):	kernel-%{1}-%{kernver}-%{kernrel}				\
Requires(preun): kernel-%{1}-%{kernver}-%{kernrel}				\
Suggests:	%{drvname}-kernel-%{1}-latest					\
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}			\
Prebuilt dkms binary kernel modules for the %{drvname} driver version %{drvver} \
built for kernel-%{1}-%{kernver}-%{kernrel}.					\
										\
%files -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%dir /var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel} \
/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-%{1}-%{kernrel}/* \
										\
%post -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms install --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
%{_sbindir}/dkms status -m %{drvname} -v %{drvver}-%{drvrel}			\
										\
%preun -n %{drvname}-kernel-%{kernver}-%{1}-%{kernrel}				\
%{_sbindir}/dkms uninstall --binary -m %{drvname} -v %{drvver}-%{drvrel} -k %{kernver}-%{1}-%{kernrel} --rpm_safe_upgrade \
										\
										\
%package -n %{drvname}-kernel-%{1}-latest					\
Summary:	Virtual rpm for latest %{drvname}-kernel-%{1} driver		\
License:	Commercial							\
URL:		http://www.nvidia.com/object/unix.html				\
Group:		System/Kernel and hardware					\
Requires:	%{drvname}-kernel-%{kernver}-%{1}-%{kernrel} = %{version}-%{release} \
%{expand:%%{?latest_obsoletes_%{1}:Obsoletes: %{latest_obsoletes_%{1}}}}	\
%{expand:%%{?latest_provides_%{1}:Provides: %{latest_provides_%{1}}}}		\
%ifarch %{ix86}									\
Conflicts:	arch(x86_64)							\
%endif										\
										\
%description -n %{drvname}-kernel-%{1}-latest					\
This package is a virtual rpm that aims to make sure you always have the	\
latest prebuilt %{drvname} driver for kernel-%{1}.				\
										\
%files -n %{drvname}-kernel-%{1}-latest

%ifarch %{ix86}
%mkflavour desktop586
%endif

%mkflavour desktop
%mkflavour server


%prep
rm -rf %{topdir}

%build
%{_sbindir}/dkms add -m %{drvname} -v %{drvver}-%{drvrel} --dkmstree %{topdir}/var/lib/dkms-binary
%ifarch %{ix86}
%{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
	    -k %{kernver}-desktop586-%{kernrel} --kernelsourcedir /usr/src/kernel-%{kernver}-desktop586-%{kernrel} \
	    --dkmstree %{topdir}/var/lib/dkms-binary
%endif
for flavour in desktop server; do
    %{_sbindir}/dkms build --no-prepare-kernel --no-clean-kernel -m %{drvname} -v %{drvver}-%{drvrel} \
		-k %{kernver}-$flavour-%{kernrel} --kernelsourcedir /usr/src/kernel-%{kernver}-$flavour-%{kernrel} \
		--dkmstree %{topdir}/var/lib/dkms-binary
done

%install
mkdir -p %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}
cp -a %{topdir}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel} \
      %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/
for dir in %{buildroot}/var/lib/dkms-binary/%{drvname}/%{drvver}-%{drvrel}/%{kernver}-*-%{kernrel}; do
    cp -a /usr/src/%{drvname}-%{drvver}-%{drvrel}/dkms.conf $dir/
    xz -6e $dir/*/module/%{drvname}.ko ||:
done


%changelog
* Sun Feb 23 2014 tmb <tmb> 304.119-5.mga4
+ Revision: 595745
- rebuild for kernel-3.12.13-2.mga4
- bump rel to allow update
- rebuild for kernel-3.12.13-1.mga4

* Fri Jan 24 2014 tmb <tmb> 304.119-2.mga4.nonfree
+ Revision: 567977
- rebuild for kernel-3.12.8-2.mga4

* Fri Jan 24 2014 tmb <tmb> 304.119-1.mga4.nonfree
+ Revision: 567600
- rebuild for nvidia304-304.119-1.mga4
- rebuild for nvidia304-304.108-3.mga4

* Sun Jan 19 2014 tmb <tmb> 304.117-8.mga4.nonfree
+ Revision: 566917
- rebuild for kernel-3.12.8-1.mga4

* Mon Jan 13 2014 tmb <tmb> 304.117-7.mga4.nonfree
+ Revision: 566410
- rebuild for kernel-3.12.7-1.mga4

* Thu Jan 09 2014 tmb <tmb> 304.117-6.mga4.nonfree
+ Revision: 566002
- rebuild for kernel-3.12.6-5.mga4

* Tue Jan 07 2014 tmb <tmb> 304.117-5.mga4.nonfree
+ Revision: 565405
- rebuild for kernel-3.12.6-4.mga4

* Sat Jan 04 2014 tmb <tmb> 304.117-4.mga4.nonfree
+ Revision: 564460
- rebuild for kernel-3.12.6-3.mga4

* Sun Dec 29 2013 tmb <tmb> 304.117-3.mga4.nonfree
+ Revision: 563043
- rebuild for kernel-3.12.6-2.mga4

* Fri Dec 20 2013 tmb <tmb> 304.117-2.mga4.nonfree
+ Revision: 559287
- rebuild for kernel-3.12.6-1.mga4

* Thu Dec 19 2013 tmb <tmb> 304.117-1.mga4.nonfree
+ Revision: 558940
- rebuild for nvidia304-304.117-1.mga4

* Sun Dec 15 2013 tmb <tmb> 304.116-6.mga4.nonfree
+ Revision: 556894
- rebuild for kernel-3.12.5-1.mga4

* Sun Dec 08 2013 tmb <tmb> 304.116-5.mga4.nonfree
+ Revision: 555899
- rebuild for nvidia304-304.116-3.mga4

* Fri Dec 06 2013 tmb <tmb> 304.116-4.mga4.nonfree
+ Revision: 555669
- rebuild for nvidia304-304.116-2.mga4

* Wed Dec 04 2013 tmb <tmb> 304.116-3.mga4.nonfree
+ Revision: 555228
- rebuild for kernel-3.12.3-1.mga4

* Sat Nov 30 2013 tmb <tmb> 304.116-2.mga4.nonfree
+ Revision: 554322
- rebuild for kernel-3.12.2-1.mga4

* Sat Nov 23 2013 tmb <tmb> 304.116-1.mga4.nonfree
+ Revision: 552581
- rebuild for nvidia304-304.116-1.mga4

* Thu Nov 21 2013 tmb <tmb> 304.108-23.mga4.nonfree
+ Revision: 552225
- rebuild for kernel-3.12.1-1.mga4

* Sun Nov 17 2013 tmb <tmb> 304.108-22.mga4.nonfree
+ Revision: 551627
- rebuild for kernel-3.12.0-3.mga4

* Sat Nov 09 2013 tmb <tmb> 304.108-21.mga4.nonfree
+ Revision: 550052
- rebuild for kernel-3.12.0-2.mga4

* Mon Nov 04 2013 tmb <tmb> 304.108-20.mga4.nonfree
+ Revision: 549336
- rebuild for kernel-3.12.0-1.mga4

* Sun Nov 03 2013 tmb <tmb> 304.108-19.mga4.nonfree
+ Revision: 549233
- rebuild for nvidia304-304.108-5.mga4

* Sat Nov 02 2013 tmb <tmb> 304.108-18.mga4.nonfree
+ Revision: 549151
- rebuild for kernel-3.12.0-0.rc7.2.mga4

* Sat Nov 02 2013 tmb <tmb> 304.108-17.mga4.nonfree
+ Revision: 549125
- rebuild for nvidia304-304.108-4.mga4

* Thu Oct 31 2013 tmb <tmb> 304.108-16.mga4.nonfree
+ Revision: 548527
- rebuild for kernel-3.12.0-0.rc7.1.mga4

* Sat Oct 26 2013 tmb <tmb> 304.108-15.mga4.nonfree
+ Revision: 547191
- rebuild for kernel-3.12.0-0.rc6.2.mga4

* Mon Oct 21 2013 tmb <tmb> 304.108-14.mga4.nonfree
+ Revision: 541229
- rebuild for kernel-3.12.0-0.rc6.1.mga4

* Wed Oct 16 2013 tmb <tmb> 304.108-13.mga4.nonfree
+ Revision: 501621
- rebuild for kernel-3.12.0-0.rc5.2.mga4

* Mon Oct 14 2013 tmb <tmb> 304.108-12.mga4.nonfree
+ Revision: 496732
- rebuild for kernel-3.12.0-0.rc5.1.mga4

* Thu Oct 03 2013 tmb <tmb> 304.108-11.mga4.nonfree
+ Revision: 490981
- rebuild for kernel-3.11.4-1.mga4

* Mon Sep 30 2013 tmb <tmb> 304.108-10.mga4.nonfree
+ Revision: 489608
- rebuild for kernel-3.11.2-2.mga4

* Fri Sep 27 2013 tmb <tmb> 304.108-9.mga4.nonfree
+ Revision: 487605
- rebuild for kernel-3.11.2-1.mga4

* Wed Sep 25 2013 tmb <tmb> 304.108-8.mga4.nonfree
+ Revision: 486408
- rebuild for kernel-3.11.1-1.mga4

* Tue Sep 03 2013 tmb <tmb> 304.108-7.mga4.nonfree
+ Revision: 474685
- rebuild for kernel-3.10.10-3.mga4

* Fri Aug 30 2013 tmb <tmb> 304.108-6.mga4.nonfree
+ Revision: 473476
- rebuild for kernel-3.10.10-2.mga4

* Thu Aug 29 2013 tmb <tmb> 304.108-5.mga4.nonfree
+ Revision: 473084
- rebuild for kernel-3.10.10-1.mga4

* Wed Aug 21 2013 tmb <tmb> 304.108-4.mga4.nonfree
+ Revision: 469180
- rebuild for kernel-3.10.9-1.mga4

* Sat Aug 17 2013 tmb <tmb> 304.108-3.mga4.nonfree
+ Revision: 467179
- rebuild for kernel-3.10.7-1.mga4

* Mon Aug 12 2013 tmb <tmb> 304.108-2.mga4.nonfree
+ Revision: 465875
- rebuild for kernel-3.10.6-1.mga4

* Mon Aug 12 2013 tmb <tmb> 304.108-1.mga4.nonfree
+ Revision: 465819
- rebuild for nvidia304-304.108-1.mga4

* Sun Aug 11 2013 tmb <tmb> 304.88-26.mga4.nonfree
+ Revision: 465477
- rebuild for kernel-3.10.5-4.mga4

* Mon Aug 05 2013 tmb <tmb> 304.88-25.mga4.nonfree
+ Revision: 464040
- rebuild for kernel-3.10.5-3.mga4

* Mon Aug 05 2013 tmb <tmb> 304.88-24.mga4.nonfree
+ Revision: 463820
- rebuild for kernel-3.10.5-2.mga4

* Sun Aug 04 2013 tmb <tmb> 304.88-23.mga4.nonfree
+ Revision: 463613
- rebuild for kernel-3.10.5-1.mga4

* Mon Jul 29 2013 tmb <tmb> 304.88-22.mga4.nonfree
+ Revision: 460449
- rebuild for kernel-3.10.4-1.mga4

* Fri Jul 26 2013 tmb <tmb> 304.88-21.mga4.nonfree
+ Revision: 458451
- rebuild for kernel-3.10.3-1.mga4

* Mon Jul 22 2013 tmb <tmb> 304.88-20.mga4.nonfree
+ Revision: 457053
- rebuild for kernel-3.10.2-1.mga4

* Mon Jul 15 2013 tmb <tmb> 304.88-19.mga4.nonfree
+ Revision: 454838
- rebuild with fixed nvidia304-304.88-4.mga4
- rebuild for kernel-3.10.1-1.mga4

* Fri Jun 28 2013 tmb <tmb> 304.88-17.mga4.nonfree
+ Revision: 447744
- rebuild for kernel-3.9.8-1.mga4

* Fri Jun 21 2013 tmb <tmb> 304.88-16.mga4.nonfree
+ Revision: 445350
- rebuild for kernel-3.9.7-1.mga4

* Tue Jun 18 2013 tv <tv> 304.88-15.mga4.nonfree
+ Revision: 444812
- rebuild for new kernel

* Sun Jun 02 2013 tmb <tmb> 304.88-14.mga4.nonfree
+ Revision: 434776
- rebuild for kernel-3.9.4-1.mga4

* Sat Jun 01 2013 sander85 <sander85> 304.88-13.mga4.nonfree
+ Revision: 434072
- Rebuild for kmod-nvidia304-304.88-3.mga4

* Tue May 14 2013 tmb <tmb> 304.88-12.mga3.nonfree
+ Revision: 413197
- rebuild for kernel-3.8.13-1.mga3

* Fri May 10 2013 tmb <tmb> 304.88-11.mga3.nonfree
+ Revision: 412837
- rebuild for kernel-3.8.12-2.mga3

* Wed May 08 2013 tmb <tmb> 304.88-10.mga3.nonfree
+ Revision: 412679
- rebuild for kernel-3.8.12-1.mga3

* Wed May 01 2013 tmb <tmb> 304.88-9.mga3.nonfree
+ Revision: 411832
- rebuild for kernel-3.8.11-1.mga3

* Sat Apr 27 2013 tmb <tmb> 304.88-8.mga3.nonfree
+ Revision: 411365
- rebuild for kernel-3.8.10-1.mga3

* Mon Apr 22 2013 tmb <tmb> 304.88-7.mga3.nonfree
+ Revision: 410894
- rebuild for kernel-3.8.8-3.mga3

* Sat Apr 20 2013 tmb <tmb> 304.88-6.mga3.nonfree
+ Revision: 410595
- rebuild for kernel-3.8.8-2.mga3

* Wed Apr 17 2013 tmb <tmb> 304.88-5.mga3.nonfree
+ Revision: 410298
- rebuild for kernel-3.8.8-1.mga3

* Sat Apr 13 2013 tmb <tmb> 304.88-4.mga3.nonfree
+ Revision: 409937
- rebuild for kernel-3.8.7-1.mga3

* Tue Apr 09 2013 tmb <tmb> 304.88-3.mga3.nonfree
+ Revision: 409297
- rebuild for kernel-3.8.6-2.mga3

* Sun Apr 07 2013 tmb <tmb> 304.88-2.mga3.nonfree
+ Revision: 408776
- rebuild for kernel-3.8.6-1.mga3

* Sun Apr 07 2013 tmb <tmb> 304.88-1.mga3.nonfree
+ Revision: 408705
- rebuild for nvidia304-304.88-1.mga3

* Sat Mar 30 2013 tmb <tmb> 304.84-3.mga3.nonfree
+ Revision: 406637
- rebuild for kernel-3.8.5-1.mga3

* Mon Mar 18 2013 tmb <tmb> 304.84-2.mga3.nonfree
+ Revision: 403972
- rebuild for kernel-3.8.3-2.mga3

* Fri Mar 15 2013 tmb <tmb> 304.84-1.mga3.nonfree
+ Revision: 403330
- rebuild for kernel-3.8.3-1.mga3
- rebuild for nvidia304 304.84

* Sat Mar 02 2013 tmb <tmb> 304.64-15.mga3.nonfree
+ Revision: 401098
- rebuild for kernel-3.8.1-1.mga3

* Thu Feb 28 2013 tmb <tmb> 304.64-14.mga3.nonfree
+ Revision: 400597
- rebuild for kernel-3.8.0-3.mga3

* Fri Feb 22 2013 tmb <tmb> 304.64-13.mga3.nonfree
+ Revision: 399994
- rebuild for kernel-3.8.0-2.mga3

* Tue Feb 19 2013 tmb <tmb> 304.64-12.mga3.nonfree
+ Revision: 399326
- rebuild for kernel-3.8.0-1.mga3

* Sat Feb 09 2013 tmb <tmb> 304.64-11.mga3.nonfree
+ Revision: 397395
- rebuild for kernel-3.8.0-0.rc7.1.mga3

* Wed Feb 06 2013 tmb <tmb> 304.64-10.mga3.nonfree
+ Revision: 394966
- rebuild for kernel-3.8.0-0.rc6.1.mga3

* Sun Jan 27 2013 tmb <tmb> 304.64-9.mga3.nonfree
+ Revision: 392639
- rebuild for kernel-3.8.0-0.rc5.1.mga3

* Fri Jan 18 2013 tmb <tmb> 304.64-8.mga3.nonfree
+ Revision: 389520
- rebuild for kernel-3.8.0-0.rc4.1.mga3

* Wed Jan 16 2013 tmb <tmb> 304.64-7.mga3.nonfree
+ Revision: 388883
- rebuild for kernel-3.8.0-0.rc3.2.mga3

* Thu Jan 10 2013 tmb <tmb> 304.64-6.mga3.nonfree
+ Revision: 344812
- rebuild with fixed nvidia304-304.64-4.mga3
- rebuild for kernel-3.8.0-0.rc3.1.mga3

* Tue Dec 18 2012 tmb <tmb> 304.64-4.mga3.nonfree
+ Revision: 332491
- rebuild for kernel-3.7.1-1.mga3

* Tue Dec 11 2012 tmb <tmb> 304.64-3.mga3.nonfree
+ Revision: 329585
- rebuild for kernel-3.7.0-1.mga3

* Fri Dec 07 2012 tmb <tmb> 304.64-2.mga3.nonfree
+ Revision: 327719
- rebuild for fixed nvidia304-304.64-3.mga3
- fix obsolete version
- kernel-netbook is gone, so have -netbook-latest packages update to
  matching -desktop-latest
- rebuild for kernel-3.7.0-0.rc8.1.mga3

* Sat Nov 24 2012 tmb <tmb> 304.64-1.mga3.nonfree
+ Revision: 321449
- imported package kmod-nvidia304

